VTK: vtkPolygonalSurfaceContourLineInterpolator Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkPolygonalSurfaceContourLineInterpolator Class Reference

Contour interpolator for to place points on polygonal surfaces. More...

`#include <vtkPolygonalSurfaceContourLineInterpolator.h>`

Inheritance diagram for vtkPolygonalSurfaceContourLineInterpolator:
[legend]
Collaboration diagram for vtkPolygonalSurfaceContourLineInterpolator:
[legend]

## Public Member Functions
int | InterpolateLine (vtkRenderer *ren, vtkContourRepresentation *rep, int idx1, int idx2) override
| Subclasses that wish to interpolate a line segment must implement this. More...
int | UpdateNode (vtkRenderer *, vtkContourRepresentation *, double *vtkNotUsed(node), int vtkNotUsed(idx)) override
| The interpolator is given a chance to update the node. More...
void | GetContourPointIds (vtkContourRepresentation *rep, vtkIdList *ids)
| Get the contour point ids. More...
virtual void | SetDistanceOffset (double)
| Height offset at which points may be placed on the polygonal surface. More...
virtual double | GetDistanceOffset ()
| Height offset at which points may be placed on the polygonal surface. More...
Public Member Functions inherited from vtkPolyDataContourLineInterpolator
virtual vtkPolyDataCollection * | GetPolys ()
| Be sure to add polydata on which you wish to place points to this list or they will not be considered for placement. More...
vtkPolyDataContourLineInterpolator * | NewInstance () const
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkContourLineInterpolator
virtual void | GetSpan (int nodeIndex, vtkIntArray *nodeIndices, vtkContourRepresentation *rep)
| Span of the interpolator. More...
vtkContourLineInterpolator * | NewInstance () const
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkPolygonalSurfaceContourLineInterpolator * | New ()
Static Public Member Functions inherited from vtkPolyDataContourLineInterpolator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkPolyDataContourLineInterpolator * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkContourLineInterpolator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkContourLineInterpolator * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkPolygonalSurfaceContourLineInterpolator ()
| ~vtkPolygonalSurfaceContourLineInterpolator () override
Protected Member Functions inherited from vtkPolyDataContourLineInterpolator
| vtkPolyDataContourLineInterpolator ()
| ~vtkPolyDataContourLineInterpolator () override
Protected Member Functions inherited from vtkContourLineInterpolator
| vtkContourLineInterpolator ()
| ~vtkContourLineInterpolator () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | DistanceOffset
| Draw the polyline at a certain height (in the direction of the vertex normal) above the polydata. More...
Protected Attributes inherited from vtkPolyDataContourLineInterpolator
vtkPolyDataCollection * | Polys
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkPolyDataContourLineInterpolator | Superclass
| Standard methods for instances of this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkPolygonalSurfaceContourLineInterpolator * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of this class. More...
vtkPolygonalSurfaceContourLineInterpolator * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of this class. More...

## Additional Inherited Members
Public Types inherited from vtkPolyDataContourLineInterpolator
typedef vtkContourLineInterpolator | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkContourLineInterpolator
typedef vtkObject | Superclass
| Standard methods for instances of this class. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Contour interpolator for to place points on polygonal surfaces.

vtkPolygonalSurfaceContourLineInterpolator interpolates and places contour points on polygonal surfaces. The class interpolates nodes by computing a graph geodesic laying on the polygonal data. By graph Geodesic, we mean that the line interpolating the two end points traverses along on the mesh edges so as to form the shortest path. A Dijkstra algorithm is used to compute the path. See vtkDijkstraGraphGeodesicPath.

The class is mean to be used in conjunction with vtkPolygonalSurfacePointPlacer. The reason for this weak coupling is a performance issue, both classes need to perform a cell pick, and coupling avoids multiple cell picks (cell picks are slow).

Warning
  You should have computed cell normals for the input polydata.

See also
  vtkDijkstraGraphGeodesicPath, vtkPolyDataNormals

Online Examples:

Tests:
  vtkPolygonalSurfaceContourLineInterpolator (Tests)

Definition at line 50 of file vtkPolygonalSurfaceContourLineInterpolator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPolyDataContourLineInterpolator vtkPolygonalSurfaceContourLineInterpolator::Superclass

Standard methods for instances of this class.

Definition at line 58 of file vtkPolygonalSurfaceContourLineInterpolator.h.

## Constructor & Destructor Documentation

## ◆ vtkPolygonalSurfaceContourLineInterpolator()

vtkPolygonalSurfaceContourLineInterpolator::vtkPolygonalSurfaceContourLineInterpolator | ( |  | ) |
| protected

## ◆ ~vtkPolygonalSurfaceContourLineInterpolator()

vtkPolygonalSurfaceContourLineInterpolator::~vtkPolygonalSurfaceContourLineInterpolator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkPolygonalSurfaceContourLineInterpolator::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instances of this class.

## ◆ IsA()

virtual vtkTypeBool vtkPolygonalSurfaceContourLineInterpolator::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of this class.

Reimplemented from vtkPolyDataContourLineInterpolator.

## ◆ SafeDownCast()

static vtkPolygonalSurfaceContourLineInterpolator* vtkPolygonalSurfaceContourLineInterpolator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instances of this class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkPolygonalSurfaceContourLineInterpolator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of this class.

Reimplemented from vtkPolyDataContourLineInterpolator.

## ◆ NewInstance()

vtkPolygonalSurfaceContourLineInterpolator* vtkPolygonalSurfaceContourLineInterpolator::NewInstance | ( |  | ) | const

Standard methods for instances of this class.

## ◆ PrintSelf()

void vtkPolygonalSurfaceContourLineInterpolator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instances of this class.

Reimplemented from vtkPolyDataContourLineInterpolator.

## ◆ New()

static vtkPolygonalSurfaceContourLineInterpolator* vtkPolygonalSurfaceContourLineInterpolator::New | ( |  | ) |
| static

## ◆ InterpolateLine()

int vtkPolygonalSurfaceContourLineInterpolator::InterpolateLine | ( | vtkRenderer * | ren,
|  | vtkContourRepresentation * | rep,
|  | int | idx1,
|  | int | idx2
| ) |  |
| overridevirtual

Subclasses that wish to interpolate a line segment must implement this.

For instance vtkBezierContourLineInterpolator adds nodes between idx1 and idx2, that allow the contour to adhere to a bezier curve.

Implements vtkPolyDataContourLineInterpolator.

## ◆ UpdateNode()

int vtkPolygonalSurfaceContourLineInterpolator::UpdateNode | ( | vtkRenderer * | ,
|  | vtkContourRepresentation * | ,
|  | double * | vtkNotUsednode,
|  | int | vtkNotUsedidx
| ) |  |
| overridevirtual

The interpolator is given a chance to update the node.

vtkImageContourLineInterpolator updates the idx'th node in the contour, so it automatically sticks to edges in the vicinity as the user constructs the contour. Returns 0 if the node (world position) is unchanged.

Implements vtkPolyDataContourLineInterpolator.

## ◆ SetDistanceOffset()

virtual void vtkPolygonalSurfaceContourLineInterpolator::SetDistanceOffset | ( | double |  | ) |
| virtual

Height offset at which points may be placed on the polygonal surface.

If you specify a non-zero value here, be sure to have computed vertex normals on your input polygonal data. (easily done with vtkPolyDataNormals).

## ◆ GetDistanceOffset()

virtual double vtkPolygonalSurfaceContourLineInterpolator::GetDistanceOffset | ( |  | ) |
| virtual

Height offset at which points may be placed on the polygonal surface.

If you specify a non-zero value here, be sure to have computed vertex normals on your input polygonal data. (easily done with vtkPolyDataNormals).

## ◆ GetContourPointIds()

void vtkPolygonalSurfaceContourLineInterpolator::GetContourPointIds | ( | vtkContourRepresentation * | rep,
|  | vtkIdList * | ids
| ) |  |

Get the contour point ids.

These point ids correspond to those on the polygonal surface

## Member Data Documentation

## ◆ DistanceOffset

double vtkPolygonalSurfaceContourLineInterpolator::DistanceOffset
| protected

Draw the polyline at a certain height (in the direction of the vertex normal) above the polydata.

Definition at line 106 of file vtkPolygonalSurfaceContourLineInterpolator.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkPolygonalSurfaceContourLineInterpolator.h